<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/os_str_bytes-6.2.0/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../os_str_bytes/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../os_str_bytes/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../os_str_bytes/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
</pre><pre class="rust"><code><span class="doccomment">//! This crate allows interacting with the data stored by [`OsStr`] and</span>
<span class="doccomment">//! [`OsString`], without resorting to panics or corruption for invalid UTF-8.</span>
<span class="doccomment">//! Thus, methods can be used that are already defined on [`[u8]`][slice] and</span>
<span class="doccomment">//! [`Vec&lt;u8&gt;`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Typically, the only way to losslessly construct [`OsStr`] or [`OsString`]</span>
<span class="doccomment">//! from a byte sequence is to use `OsStr::new(str::from_utf8(bytes)?)`, which</span>
<span class="doccomment">//! requires the bytes to be valid in UTF-8. However, since this crate makes</span>
<span class="doccomment">//! conversions directly between the platform encoding and raw bytes, even some</span>
<span class="doccomment">//! strings invalid in UTF-8 can be converted.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In most cases, [`RawOsStr`] and [`RawOsString`] should be used.</span>
<span class="doccomment">//! [`OsStrBytes`] and [`OsStringBytes`] provide lower-level APIs that are</span>
<span class="doccomment">//! easier to misuse.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Encoding</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The encoding of bytes returned or accepted by methods of this crate is</span>
<span class="doccomment">//! intentionally left unspecified. It may vary for different platforms, so</span>
<span class="doccomment">//! defining it would run contrary to the goal of generic string handling.</span>
<span class="doccomment">//! However, the following invariants will always be upheld:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - The encoding will be compatible with UTF-8. In particular, splitting an</span>
<span class="doccomment">//!   encoded byte sequence by a UTF-8–encoded character always produces other</span>
<span class="doccomment">//!   valid byte sequences. They can be re-encoded without error using</span>
<span class="doccomment">//!   [`OsStrBytes::from_raw_bytes`] and similar methods.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - All characters valid in platform strings are representable. [`OsStr`] and</span>
<span class="doccomment">//!   [`OsString`] can always be losslessly reconstructed from extracted bytes.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Note that the chosen encoding may not match how Rust stores these strings</span>
<span class="doccomment">//! internally, which is undocumented. For instance, the result of calling</span>
<span class="doccomment">//! [`OsStr::len`] will not necessarily match the number of bytes this crate</span>
<span class="doccomment">//! uses to represent the same string.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Additionally, concatenation may yield unexpected results without a UTF-8</span>
<span class="doccomment">//! separator. If two platform strings need to be concatenated, the only safe</span>
<span class="doccomment">//! way to do so is using [`OsString::push`]. This limitation also makes it</span>
<span class="doccomment">//! undesirable to use the bytes in interchange.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Since this encoding can change between versions and platforms, it should</span>
<span class="doccomment">//! not be used for storage. The standard library provides implementations of</span>
<span class="doccomment">//! [`OsStrExt`] and [`OsStringExt`] for various platforms, which should be</span>
<span class="doccomment">//! preferred for that use case.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # User Input</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Traits in this crate should ideally not be used to convert byte sequences</span>
<span class="doccomment">//! that did not originate from [`OsStr`] or a related struct. The encoding</span>
<span class="doccomment">//! used by this crate is an implementation detail, so it does not make sense</span>
<span class="doccomment">//! to expose it to users.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Crate [bstr] offers some useful alternative methods, such as</span>
<span class="doccomment">//! [`ByteSlice::to_os_str`] and [`ByteVec::into_os_string`], that are meant</span>
<span class="doccomment">//! for user input. But, they reject some byte sequences used to represent</span>
<span class="doccomment">//! valid platform strings, which would be undesirable for reliable path</span>
<span class="doccomment">//! handling. They are best used only when accepting unknown input.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This crate is meant to help when you already have an instance of [`OsStr`]</span>
<span class="doccomment">//! and need to modify the data in a lossless way.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Features</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! These features are optional and can be enabled or disabled in a</span>
<span class="doccomment">//! &quot;Cargo.toml&quot; file.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ### Default Features</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - **memchr** -</span>
<span class="doccomment">//!   Changes the implementation to use crate [memchr] for better performance.</span>
<span class="doccomment">//!   This feature is useless when &quot;raw\_os\_str&quot; is disabled.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   For more information, see [`RawOsStr`][memchr complexity].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - **raw\_os\_str** -</span>
<span class="doccomment">//!   Provides [`RawOsStr`] and [`RawOsString`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ### Optional Features</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - **print\_bytes** -</span>
<span class="doccomment">//!   Provides implementations of [`print_bytes::ToBytes`] for [`RawOsStr`] and</span>
<span class="doccomment">//!   [`RawOsString`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - **uniquote** -</span>
<span class="doccomment">//!   Provides implementations of [`uniquote::Quote`] for [`RawOsStr`] and</span>
<span class="doccomment">//!   [`RawOsString`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Implementation</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Some methods return [`Cow`] to account for platform differences. However,</span>
<span class="doccomment">//! no guarantee is made that the same variant of that enum will always be</span>
<span class="doccomment">//! returned for the same platform. Whichever can be constructed most</span>
<span class="doccomment">//! efficiently will be returned.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! All traits are [sealed], meaning that they can only be implemented by this</span>
<span class="doccomment">//! crate. Otherwise, backward compatibility would be more difficult to</span>
<span class="doccomment">//! maintain for new features.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Complexity</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The time complexities of trait methods will vary based on what</span>
<span class="doccomment">//! functionality is available for the platform. At worst, they will all be</span>
<span class="doccomment">//! linear, but some can take constant time. For example,</span>
<span class="doccomment">//! [`OsStringBytes::from_raw_vec`] might be able to reuse the allocation for</span>
<span class="doccomment">//! its argument.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Examples</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! # use std::io;</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! # #[cfg(feature = &quot;raw_os_str&quot;)]</span>
<span class="doccomment">//! # {</span>
<span class="doccomment">//! # #[cfg(any())]</span>
<span class="doccomment">//! use std::env;</span>
<span class="doccomment">//! use std::fs;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! use os_str_bytes::RawOsStr;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # mod env {</span>
<span class="doccomment">//! #   use std::env;</span>
<span class="doccomment">//! #   use std::ffi::OsString;</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! #   pub fn args_os() -&gt; impl Iterator&lt;Item = OsString&gt; {</span>
<span class="doccomment">//! #       let mut file = env::temp_dir();</span>
<span class="doccomment">//! #       file.push(&quot;os_str_bytes\u{E9}.txt&quot;);</span>
<span class="doccomment">//! #       return vec![OsString::new(), file.into_os_string()].into_iter();</span>
<span class="doccomment">//! #   }</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! for file in env::args_os().skip(1) {</span>
<span class="doccomment">//!     if !RawOsStr::new(&amp;file).starts_with(&#39;-&#39;) {</span>
<span class="doccomment">//!         let string = &quot;Hello, world!&quot;;</span>
<span class="doccomment">//!         fs::write(&amp;file, string)?;</span>
<span class="doccomment">//!         assert_eq!(string, fs::read_to_string(file)?);</span>
<span class="doccomment">//!     }</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! # Ok::&lt;_, io::Error&gt;(())</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [bstr]: https://crates.io/crates/bstr</span>
<span class="doccomment">//! [`ByteSlice::to_os_str`]: https://docs.rs/bstr/0.2.12/bstr/trait.ByteSlice.html#method.to_os_str</span>
<span class="doccomment">//! [`ByteVec::into_os_string`]: https://docs.rs/bstr/0.2.12/bstr/trait.ByteVec.html#method.into_os_string</span>
<span class="doccomment">//! [memchr complexity]: RawOsStr#complexity</span>
<span class="doccomment">//! [memchr]: https://crates.io/crates/memchr</span>
<span class="doccomment">//! [`OsStrExt`]: ::std::os::unix::ffi::OsStrExt</span>
<span class="doccomment">//! [`OsStringExt`]: ::std::os::unix::ffi::OsStringExt</span>
<span class="doccomment">//! [sealed]: https://rust-lang.github.io/api-guidelines/future-proofing.html#c-sealed</span>
<span class="doccomment">//! [print\_bytes]: https://crates.io/crates/print_bytes</span>

<span class="comment">// Only require a nightly compiler when building documentation for docs.rs.</span>
<span class="comment">// This is a private option that should not be used.</span>
<span class="comment">// https://github.com/rust-lang/docs.rs/issues/147#issuecomment-389544407</span>
<span class="comment">// https://github.com/dylni/os_str_bytes/issues/2</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">os_str_bytes_docs_rs</span>, <span class="ident">feature</span>(<span class="ident">doc_cfg</span>))]</span>
<span class="comment">// Nightly is also currently required for the SGX platform.</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(
    <span class="ident">all</span>(<span class="ident">target_vendor</span> <span class="op">=</span> <span class="string">&quot;fortanix&quot;</span>, <span class="ident">target_env</span> <span class="op">=</span> <span class="string">&quot;sgx&quot;</span>),
    <span class="ident">feature</span>(<span class="ident">sgx_platform</span>)
)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">unsafe_op_in_unsafe_fn</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">unused_results</span>)]</span>

<span class="kw">use</span> <span class="ident">std::borrow::Cow</span>;
<span class="kw">use</span> <span class="ident">std::error::Error</span>;
<span class="kw">use</span> <span class="ident">std::ffi::OsStr</span>;
<span class="kw">use</span> <span class="ident">std::ffi::OsString</span>;
<span class="kw">use</span> <span class="ident">std::fmt</span>;
<span class="kw">use</span> <span class="ident">std::fmt::Display</span>;
<span class="kw">use</span> <span class="ident">std::fmt::Formatter</span>;
<span class="kw">use</span> <span class="ident">std::path::Path</span>;
<span class="kw">use</span> <span class="ident">std::path::PathBuf</span>;
<span class="kw">use</span> <span class="ident">std::result</span>;

<span class="macro">macro_rules!</span> <span class="ident">if_raw_str</span> {
    ( $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">item</span>:<span class="ident">item</span>)<span class="op">+</span> ) =&gt; {
        $(
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;raw_os_str&quot;</span>)]</span>
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">item</span>
        )<span class="op">+</span>
    };
}

<span class="macro">if_raw_str!</span> {
    <span class="macro">macro_rules!</span> <span class="ident">expect_encoded</span> {
        ( <span class="macro-nonterminal">$</span><span class="macro-nonterminal">result</span>:<span class="ident">expr</span> ) =&gt; {
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">result</span>.<span class="ident">expect</span>(<span class="string">&quot;invalid raw bytes&quot;</span>)
        };
    }
}

<span class="attribute">#[<span class="ident">cfg_attr</span>(
    <span class="ident">all</span>(<span class="ident">target_family</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>),
    <span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;wasm/mod.rs&quot;</span>
)]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">windows</span>, <span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;windows/mod.rs&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(
    <span class="ident">not</span>(<span class="ident">any</span>(<span class="ident">all</span>(<span class="ident">target_family</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>), <span class="ident">windows</span>)),
    <span class="ident">path</span> <span class="op">=</span> <span class="string">&quot;common/mod.rs&quot;</span>
)]</span>
<span class="kw">mod</span> <span class="ident">imp</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
    <span class="ident">all</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;raw_os_str&quot;</span>,
        <span class="ident">target_family</span> <span class="op">=</span> <span class="string">&quot;wasm&quot;</span>,
        <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>,
    ),
    <span class="ident">windows</span>,
))]</span>
<span class="kw">mod</span> <span class="ident">util</span>;

<span class="macro">if_raw_str!</span> {
    <span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">iter</span>;

    <span class="kw">mod</span> <span class="ident">pattern</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">pattern::Pattern</span>;

    <span class="kw">mod</span> <span class="ident">raw_str</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">raw_str::RawOsStr</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident">raw_str::RawOsString</span>;
}

<span class="doccomment">/// The error that occurs when a byte sequence is not representable in the</span>
<span class="doccomment">/// platform encoding.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Result::unwrap`] should almost always be called on results containing</span>
<span class="doccomment">/// this error. It should be known whether or not byte sequences are properly</span>
<span class="doccomment">/// encoded for the platform, since [the module-level documentation][encoding]</span>
<span class="doccomment">/// discourages using encoded bytes in interchange. Results are returned</span>
<span class="doccomment">/// primarily to make panicking behavior explicit.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// On Unix, this error is never returned, but [`OsStrExt`] or [`OsStringExt`]</span>
<span class="doccomment">/// should be used instead if that needs to be guaranteed.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [encoding]: self#encoding</span>
<span class="doccomment">/// [`OsStrExt`]: ::std::os::unix::ffi::OsStrExt</span>
<span class="doccomment">/// [`OsStringExt`]: ::std::os::unix::ffi::OsStringExt</span>
<span class="doccomment">/// [`Result::unwrap`]: ::std::result::Result::unwrap</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Eq</span>, <span class="ident">PartialEq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">EncodingError</span>(<span class="ident">imp::EncodingError</span>);

<span class="kw">impl</span> <span class="ident">Display</span> <span class="kw">for</span> <span class="ident">EncodingError</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">fmt</span>(<span class="ident">f</span>)
    }
}

<span class="kw">impl</span> <span class="ident">Error</span> <span class="kw">for</span> <span class="ident">EncodingError</span> {}

<span class="kw">type</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">EncodingError</span><span class="op">&gt;</span>;

<span class="doccomment">/// A platform agnostic variant of [`OsStrExt`].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For more information, see [the module-level documentation][module].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [module]: self</span>
<span class="doccomment">/// [`OsStrExt`]: ::std::os::unix::ffi::OsStrExt</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">OsStrBytes</span>: <span class="ident">private::Sealed</span> <span class="op">+</span> <span class="ident">ToOwned</span> {
    <span class="doccomment">/// Converts a byte slice into an equivalent platform-native string.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Provided byte strings should always be valid for the [unspecified</span>
    <span class="doccomment">/// encoding] used by this crate.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Errors</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// See documentation for [`EncodingError`].</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::env;</span>
    <span class="doccomment">/// use std::ffi::OsStr;</span>
    <span class="doccomment">/// # use std::io;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// use os_str_bytes::OsStrBytes;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let os_string = env::current_exe()?;</span>
    <span class="doccomment">/// let os_bytes = os_string.to_raw_bytes();</span>
    <span class="doccomment">/// assert_eq!(os_string, OsStr::from_raw_bytes(os_bytes).unwrap());</span>
    <span class="doccomment">/// #</span>
    <span class="doccomment">/// # Ok::&lt;_, io::Error&gt;(())</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [unspecified encoding]: self#encoding</span>
    <span class="kw">fn</span> <span class="ident">from_raw_bytes</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">S</span><span class="op">&gt;</span>(<span class="ident">string</span>: <span class="ident">S</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="self">Self</span><span class="op">&gt;</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">S</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, [<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Converts a platform-native string into an equivalent byte slice.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The returned byte string will use an [unspecified encoding].</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::env;</span>
    <span class="doccomment">/// # use std::io;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// use os_str_bytes::OsStrBytes;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let os_string = env::current_exe()?;</span>
    <span class="doccomment">/// println!(&quot;{:?}&quot;, os_string.to_raw_bytes());</span>
    <span class="doccomment">/// #</span>
    <span class="doccomment">/// # Ok::&lt;_, io::Error&gt;(())</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [unspecified encoding]: self#encoding</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">fn</span> <span class="ident">to_raw_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, [<span class="ident">u8</span>]<span class="op">&gt;</span>;
}

<span class="kw">impl</span> <span class="ident">OsStrBytes</span> <span class="kw">for</span> <span class="ident">OsStr</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">from_raw_bytes</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">S</span><span class="op">&gt;</span>(<span class="ident">string</span>: <span class="ident">S</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="self">Self</span><span class="op">&gt;</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">S</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, [<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>,
    {
        <span class="kw">match</span> <span class="ident">string</span>.<span class="ident">into</span>() {
            <span class="ident">Cow::Borrowed</span>(<span class="ident">string</span>) =&gt; {
                <span class="ident">imp::os_str_from_bytes</span>(<span class="ident">string</span>).<span class="ident">map_err</span>(<span class="ident">EncodingError</span>)
            }
            <span class="ident">Cow::Owned</span>(<span class="ident">string</span>) =&gt; {
                <span class="ident">OsStringBytes::from_raw_vec</span>(<span class="ident">string</span>).<span class="ident">map</span>(<span class="ident">Cow::Owned</span>)
            }
        }
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">to_raw_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, [<span class="ident">u8</span>]<span class="op">&gt;</span> {
        <span class="ident">imp::os_str_to_bytes</span>(<span class="self">self</span>)
    }
}

<span class="kw">impl</span> <span class="ident">OsStrBytes</span> <span class="kw">for</span> <span class="ident">Path</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">from_raw_bytes</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">S</span><span class="op">&gt;</span>(<span class="ident">string</span>: <span class="ident">S</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="self">Self</span><span class="op">&gt;</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">S</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, [<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>,
    {
        <span class="ident">OsStr::from_raw_bytes</span>(<span class="ident">string</span>).<span class="ident">map</span>(<span class="op">|</span><span class="ident">os_string</span><span class="op">|</span> <span class="kw">match</span> <span class="ident">os_string</span> {
            <span class="ident">Cow::Borrowed</span>(<span class="ident">os_string</span>) =&gt; <span class="ident">Cow::Borrowed</span>(<span class="ident"><span class="self">Self</span>::new</span>(<span class="ident">os_string</span>)),
            <span class="ident">Cow::Owned</span>(<span class="ident">os_string</span>) =&gt; <span class="ident">Cow::Owned</span>(<span class="ident">os_string</span>.<span class="ident">into</span>()),
        })
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">to_raw_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Cow</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span>, [<span class="ident">u8</span>]<span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">as_os_str</span>().<span class="ident">to_raw_bytes</span>()
    }
}

<span class="doccomment">/// A platform agnostic variant of [`OsStringExt`].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For more information, see [the module-level documentation][module].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [module]: self</span>
<span class="doccomment">/// [`OsStringExt`]: ::std::os::unix::ffi::OsStringExt</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">OsStringBytes</span>: <span class="ident">private::Sealed</span> <span class="op">+</span> <span class="ident">Sized</span> {
    <span class="doccomment">/// Converts a byte vector into an equivalent platform-native string.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Provided byte strings should always be valid for the [unspecified</span>
    <span class="doccomment">/// encoding] used by this crate.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Errors</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// See documentation for [`EncodingError`].</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::env;</span>
    <span class="doccomment">/// use std::ffi::OsString;</span>
    <span class="doccomment">/// # use std::io;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// use os_str_bytes::OsStringBytes;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let os_string = env::current_exe()?;</span>
    <span class="doccomment">/// let os_bytes = os_string.clone().into_raw_vec();</span>
    <span class="doccomment">/// assert_eq!(os_string, OsString::from_raw_vec(os_bytes).unwrap());</span>
    <span class="doccomment">/// #</span>
    <span class="doccomment">/// # Ok::&lt;_, io::Error&gt;(())</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [unspecified encoding]: self#encoding</span>
    <span class="kw">fn</span> <span class="ident">from_raw_vec</span>(<span class="ident">string</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span>;

    <span class="doccomment">/// Converts a platform-native string into an equivalent byte vector.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The returned byte string will use an [unspecified encoding].</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use std::env;</span>
    <span class="doccomment">/// # use std::io;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// use os_str_bytes::OsStringBytes;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let os_string = env::current_exe()?;</span>
    <span class="doccomment">/// println!(&quot;{:?}&quot;, os_string.into_raw_vec());</span>
    <span class="doccomment">/// #</span>
    <span class="doccomment">/// # Ok::&lt;_, io::Error&gt;(())</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [unspecified encoding]: self#encoding</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">fn</span> <span class="ident">into_raw_vec</span>(<span class="self">self</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>;
}

<span class="kw">impl</span> <span class="ident">OsStringBytes</span> <span class="kw">for</span> <span class="ident">OsString</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">from_raw_vec</span>(<span class="ident">string</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
        <span class="ident">imp::os_string_from_vec</span>(<span class="ident">string</span>).<span class="ident">map_err</span>(<span class="ident">EncodingError</span>)
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">into_raw_vec</span>(<span class="self">self</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
        <span class="ident">imp::os_string_into_vec</span>(<span class="self">self</span>)
    }
}

<span class="kw">impl</span> <span class="ident">OsStringBytes</span> <span class="kw">for</span> <span class="ident">PathBuf</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">from_raw_vec</span>(<span class="ident">string</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
        <span class="ident">OsString::from_raw_vec</span>(<span class="ident">string</span>).<span class="ident">map</span>(<span class="ident">Into::into</span>)
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">into_raw_vec</span>(<span class="self">self</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">into_os_string</span>().<span class="ident">into_raw_vec</span>()
    }
}

<span class="kw">mod</span> <span class="ident">private</span> {
    <span class="kw">use</span> <span class="ident">std::ffi::OsStr</span>;
    <span class="kw">use</span> <span class="ident">std::ffi::OsString</span>;
    <span class="kw">use</span> <span class="ident">std::path::Path</span>;
    <span class="kw">use</span> <span class="ident">std::path::PathBuf</span>;

    <span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Sealed</span> {}
    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="ident">char</span> {}
    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="ident">OsStr</span> {}
    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="ident">OsString</span> {}
    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="ident">Path</span> {}
    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="ident">PathBuf</span> {}
    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="ident">str</span> {}
    <span class="kw">impl</span> <span class="ident">Sealed</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="ident">String</span> {}
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="os_str_bytes" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>